/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package po_cw14;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.media.opengl.*;
import javax.media.opengl.awt.GLCanvas;
import com.jogamp.opengl.util.*;
import com.jogamp.opengl.util.gl2.GLUT;
import javax.media.opengl.glu.GLU;

public class Cube implements GLEventListener {
    private GLU glu;
    private GLUT glut;

    private float r=3;
    private float a = 0;
    
    public static void main(String[] args) {
        GLProfile glp = GLProfile.getDefault();
        GLCapabilities caps = new GLCapabilities(glp);
        GLCanvas canvas = new GLCanvas(caps);

        Frame frame = new Frame("Cube");
        frame.setSize(300, 300);
        frame.add(canvas);
        frame.setVisible(true);

        frame.addWindowListener(new WindowAdapter() {

            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

        canvas.addGLEventListener(new Cube());

        FPSAnimator animator = new FPSAnimator(canvas, 60);
        animator.add(canvas);
        animator.start();
    }

    @Override
    public void display(GLAutoDrawable drawable) {
        update();
        render(drawable);
    }

    @Override
    public void dispose(GLAutoDrawable drawable) {
    }

    @Override
    public void init(GLAutoDrawable drawable) {
        glu=new GLU();
        glut=new GLUT();
    }

    @Override
    public void reshape(GLAutoDrawable drawable, int x, int y, int w, int h) {
    }

    private void update() {
        a = (a + (float) Math.PI / 300f);
    }

    private void lights(GLAutoDrawable drawable, GL2 gl) {

        float light_ambient[] = {0.2f, 0.2f, 0.2f, 1.0f};
        float light_diffuse[] = {0.8f, 0.8f, 0.8f, 1.0f};
        float light_specular[] = {0.5f, 0.5f, 0.5f, 1.0f};

        float light0_position[] = {-4.0f, 4.0f, -2.0f, 0.0f};


        gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_AMBIENT, light_ambient, 0);
        gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_DIFFUSE, light_diffuse, 0);
        gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_SPECULAR, light_specular, 0);
        gl.glLightfv(GL2.GL_LIGHT0, GL2.GL_POSITION, light0_position, 0);


        gl.glEnable(GL2.GL_LIGHTING);
        gl.glEnable(GL2.GL_LIGHT0);
        

        gl.glShadeModel(GL2.GL_SMOOTH);
        gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
        gl.glClearDepth(1.0f);
        gl.glEnable(GL.GL_DEPTH_TEST);
        gl.glDepthFunc(GL.GL_LEQUAL);
        gl.glHint(GL2.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);

    }

    private void camera(GLAutoDrawable drawable, GL2 gl) {
        int width = drawable.getWidth();
        int height = drawable.getHeight();

        glu.gluPerspective(70.0, (float) width / (float) height, 1, 50);
        glu.gluLookAt(r * Math.sin(a), 0, r * Math.cos(a), 0, 0, 0, 0.0, 1.0, 0.0);
    }

    private void scene(GLAutoDrawable drawable, GL2 gl) {
        gl.glEnable(GL2.GL_COLOR_MATERIAL);
        glut.glutSolidCube(1);    
    }
    
    private void render(GLAutoDrawable drawable) {
        GL2 gl = drawable.getGL().getGL2();

        int width = drawable.getWidth();
        int height = drawable.getHeight();

        gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);

        gl.glViewport(0, 0, width, height);			

        gl.glMatrixMode(GL2.GL_PROJECTION);			
        gl.glLoadIdentity();					
        
        
        camera(drawable, gl);
        lights(drawable, gl);

        gl.glMatrixMode(GL2.GL_MODELVIEW);			
        gl.glLoadIdentity();

        scene(drawable,gl);
    }
}
